<?php
namespace Fiscal\Logic\ImportaGeneroProd;
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of GeneroProdutoSped
 *
 * @author carinaoliveira
 */
use Geral\Entities\GeneroProd;
use Fiscal\Entities\Generoitemsped as genitemsped;
use Geral\Util\DateUtil;
use Geral\Util\Ambiente;
use Indeterminado\Entities\RelacProdItGen;
use Setforms2\Shared\Registry;

class GeneroProdutoSped {

    public static function replicaGeneroProd($nrorg, $cdLivroDest) {

        /*Valida se existe algum cadastro de Produto por Tp. Item/Gênero pois assim os tipos de itens atuais não podem ser substituídos.*/
        $proditgen = RelacProdItGen::findByNrorgAndCdlivromag($nrorg, $cdLivroDest);
        if ($proditgen == null) {
            $connection = Registry::getEntityManagerConnection();
            $connection->beginTransaction();

            try {
                self::replicaRegistrosGenero($nrorg, $cdLivroDest);
                $connection->commit();
            } catch (\Exception $e) {
                $connection->rollback();
                throw $e;
            }

        } else {
            throw new \Exception ("Operação Bloqueada! Os cadastros não podem ser substituídos pois estão sendo usados na aba Produto por Tipo de Item/Gênero.");
        }
    }


    public static function replicaRegistrosGenero($nrorg, $cdLivroDest)
    {
        /*A função replica os gêneros do produto entre um livro e a tabela padrao de sped conforme os parâmetros informados, de forma que,
          são excluídos todos os gêneros do livro de destino e então são inseridos todos os cadastros da tabela padrao de sped 
         *para o livro de destino.*/

        $dataAtual = DateUtil::getDataAtual();
        $cdoperador = Ambiente::getCdOperador();

        try {

            /*São apagados os cadastros de Gênero do produto do livro de destino para serem incluídos os novos.*/
            $repositorioGeneroProd = GeneroProd::getRepository();
            $repositorioGeneroProd->deleteByCdlivromagAndNrorg($cdLivroDest, $nrorg);
            Registry::getEntityManager()->flush();

            /*São buscados todos os generos do produto da tabela de sped e para cada um são criados novos itens com o código do livro de destino.*/
            $generos = genitemsped::getObjectsByWhere('1=1');

            foreach ($generos as $genero) {
                $newgenero = new GeneroProd();
                $newgenero->setCdlivromag($cdLivroDest);
                $newgenero->setCdgenprod($genero->getCdgeneroitem());
                $newgenero->setDsgenprod($genero->getDsgeneroitem());
                $newgenero->setNrorginclusao($nrorg);
                $newgenero->setCdoperultatu($cdoperador);
                $newgenero->setNrorg($nrorg);
                $newgenero->setDtinclusao($dataAtual);
                $newgenero->setDtultatu($dataAtual);
                $newgenero->setNrorgultatu($nrorg);
                $newgenero->setCdoperinclusao($cdoperador);

                /*Um a um os gêneros são persistidos. O flush é executado na função de origem 'replicaGeneroProd'.*/
                $newgenero->persist();
            }

            Registry::getEntityManager()->flush();

        } catch (\Exception $e) {
            throw $e;
        }

    }
    
}

?>
