/* Procedure para gerar baixa*/
IF EXISTS (SELECT * FROM sysobjects O, sysusers U
           WHERE
            o.name = 'GERA_BAIXA'  and
            type = 'P'                        and
            u.uid = o.uid                     and
            u.name = USER)

   DROP PROCEDURE GERA_BAIXA;
GO

CREATE PROCEDURE GERA_BAIXA(
   @P_IDENTRSAID    VARCHAR(1),
   @P_CDEMPRESA     VARCHAR(2),
   @P_CDFILIAL      VARCHAR(4),
   @P_NRLANBOL      VARCHAR(20),
   @P_FILIPROC      VARCHAR(4),
   @P_DTBAIXA       DATETIME,
   @P_CDCONTCORR    VARCHAR(3),
   @P_CDTIPOBAIXA   VARCHAR(2),
   @P_CDOPERADOR    VARCHAR(12))
AS
   DECLARE @V_NRMOVBANC    VARCHAR(20);
   DECLARE @V_NRRECIBO     VARCHAR(20);
   DECLARE @V_NRBAIXA      VARCHAR(20);
   DECLARE @V_CDHISTPADR   VARCHAR(4);
   DECLARE @V_DSHISTPADR   VARCHAR(60);
   DECLARE @V_NRLANCTONF   VARCHAR(10);
   DECLARE @V_NRSEQVENREC  VARCHAR(2);
   DECLARE @V_VRORIGREC    double precision;
   DECLARE @V_CDFILIBOLREC VARCHAR(4);
   DECLARE @V_CDCLASSFINA  VARCHAR(6);
   DECLARE @V_CDEMPRESA    VARCHAR(2);
   DECLARE @V_CDFIMOVFLREC VARCHAR(4);
   DECLARE @V_DTMOVFLUXO   DATETIME;
   DECLARE @V_IDMOVFLUXO   VARCHAR(1);
   DECLARE @V_DTPROC       DATETIME;
   DECLARE @V_NRPARCELAREC VARCHAR(2);
   DECLARE @V_VRFINALBREC  double precision;
   DECLARE @V_DTSALDO      DATETIME;
   DECLARE @V_VRATUAL      double precision;
   DECLARE @VRSDOCCORR     double precision;
   DECLARE @VRSDOIMPLA     double precision;
   DECLARE @CONCAT1        VARCHAR(30);
   DECLARE @CONCAT2        VARCHAR(30);
   DECLARE @CONCAT3        VARCHAR(30);
   DECLARE @CONCAT4        VARCHAR(30);
   DECLARE @ANO            VARCHAR(10);
   DECLARE @MES            VARCHAR(10);
   DECLARE @ANOMES         VARCHAR(10);
   DECLARE @V_STATUS       VARCHAR(1);
   DECLARE @V_DTFERIADO    DATETIME;
   DECLARE @V_DTBAIXAREC   DATETIME;
   DECLARE @V_IDCOFERIBANC VARCHAR(1);

BEGIN

   SELECT @V_IDCOFERIBANC = MAX(IDCOFERIBANC)
     FROM PARAMGERAL

   SET @V_DTBAIXAREC = @P_DTBAIXA;

   /*Considera feriado bancrio para gerar a baixa*/
   IF (@V_IDCOFERIBANC = 'S') BEGIN

     SELECT @V_DTFERIADO = MAX(DTFERIBANC)
       FROM FERIBANC
      WHERE CDFILIAL   = @P_FILIPROC
        AND DTFERIBANC = @V_DTBAIXAREC;

     WHILE (@V_DTFERIADO = @V_DTBAIXAREC) BEGIN
         SET @V_DTBAIXAREC = @V_DTBAIXAREC + 1;
         SELECT @V_DTFERIADO = MAX(DTFERIBANC)
           FROM FERIBANC
          WHERE CDFILIAL   = @P_FILIPROC
            AND DTFERIBANC = @V_DTBAIXAREC;
     END;
   END;

   SET @P_DTBAIXA   = CONVERT(VARCHAR, @V_DTBAIXAREC,12)
   SET @V_VRORIGREC = (@V_VRORIGREC * -1)

   SET @CONCAT1     = 'MOVBANCARIO'+@P_CDCONTCORR;
   EXEC NOVO_CODIGO @CONCAT1, @P_SEQUENCIAL = @V_NRMOVBANC OUTPUT ;
   SET @V_NRMOVBANC = SUBSTRING(@V_NRMOVBANC, 11, 10);

   SET @ANO = MONTH(@V_DTBAIXAREC);
   SET @MES = YEAR(@V_DTBAIXAREC);
   SET @ANOMES = @ANO+@MES;

   EXEC NOVO_CODIGO 'NRRECIBOREC', @P_SEQUENCIAL = @V_NRRECIBO OUTPUT;
   SET @V_NRRECIBO = SUBSTRING(@V_NRRECIBO, 11, 10);

   SET @CONCAT4 = 'BAIXARECEBIDA'+@P_FILIPROC;
   EXEC NOVO_CODIGO @CONCAT4, @P_SEQUENCIAL = @V_NRBAIXA OUTPUT;
   SET @V_NRBAIXA = SUBSTRING(@V_NRBAIXA, 11, 10);

   SELECT @V_CDHISTPADR = MAX(T.CDHISTPADR),
          @V_DSHISTPADR = MAX(H.DSHISTPADR)
     FROM TIPOBAIXAREC T, HISTPADR H
    WHERE T.CDTPBAIXAREC = @P_CDTIPOBAIXA
      AND T.CDHISTPADR   = H.CDHISTPADR;

   SELECT @V_VRFINALBREC = MAX(VRFINALBREC)
     FROM BOLETRECEBER
    WHERE CDFILIAL    = @P_FILIPROC
      AND NRLANBOLREC = @P_NRLANBOL;

   SELECT @V_NRLANCTONF    = MAX(CR.NRLANCTONF),
          @V_NRSEQVENREC   = MAX(CR.NRSEQVENREC),
          @V_NRPARCELAREC  = MAX(CR.NRPARCELAREC),
          @V_VRORIGREC     = MAX(CR.VRORIGREC),
          @V_CDFILIBOLREC  = MAX(CR.CDFILIBOLREC),
          @V_CDCLASSFINA   = MAX(CR.CDCLASSFINA),
          @V_CDEMPRESA     = MAX(CR.CDEMPRESA),
          @V_CDFIMOVFLREC  = MAX(CR.CDFIMOVFLREC),
          @V_DTMOVFLUXO    = MAX(CR.DTMOVFLUXO),
          @V_IDMOVFLUXO    = MAX(CR.IDMOVFLUXO)
     FROM CONTARECEBER CR
    WHERE (CR.CDFILIAL     = @P_FILIPROC)
      AND (CR.NRLANBOLREC  = @P_NRLANBOL );

   SET @V_VRORIGREC = @V_VRORIGREC * -1;

   EXEC ATUALIZA_FLUXO_DE_CAIXA @V_CDEMPRESA,
                                @V_CDFIMOVFLREC,
                                @V_DTMOVFLUXO,
                                @V_IDMOVFLUXO,
                                @V_CDCLASSFINA,
                                @V_VRORIGREC,
                                0;

   SET @V_VRORIGREC = @V_VRORIGREC * (-1);

   EXEC ATUALIZA_FLUXO_DE_CAIXA @V_CDEMPRESA,
                                @V_CDFIMOVFLREC,
                                @V_DTBAIXAREC,
                                'R',
                                @V_CDCLASSFINA,
                                @V_VRORIGREC,
                                0;

   /*Atualiza a conta com os dados do recebibento*/
   UPDATE CONTARECEBER
      SET IDMOVFLUXO = 'R',
          IDSTATREC  = 'B',
          DTMOVFLUXO = @V_DTBAIXAREC
    WHERE CDFILIAL     = @P_FILIPROC
      AND NRLANCTONF   = @V_NRLANCTONF
      AND NRSEQVENREC  = @V_NRSEQVENREC
      AND NRPARCELAREC = @V_NRPARCELAREC;

   SET @V_STATUS = (SELECT IDSTATREC
                      FROM CONTARECEBER
                     WHERE CDFILIAL     = @P_FILIPROC
                       AND NRLANCTONF   = @V_NRLANCTONF
                       AND NRSEQVENREC  = @V_NRSEQVENREC
                       AND NRPARCELAREC = @V_NRPARCELAREC)

   INSERT INTO MOVBANCARIO
      (CDREDUCONT, NRMOVBANC,  DTMOVBANC, IDMOVBANC,
       NRDOCMBANC, DSHISMBANC, VRMOVBANC, IDORIGMBANC)
   VALUES
      (@P_CDCONTCORR, @V_NRMOVBANC, @V_DTBAIXAREC, 'C',
       '', 'bxRec',   @V_VRORIGREC, 'R');

   INSERT INTO BAIXARECEBIDA
      (CDEMPRESA,    NRMOVBANC,    NRBAIXAREC, NRRECIBOREC,
       IDSTATUSBREC, CDFILIAL,     DTBAIXAREC, VRBAIXAREC,
       CDREDUCONT,   CDTPBAIXAREC, CDOPERADOR, DTLANCBAIXAR,
       DSBAIXAREC)
   VALUES
      (@V_CDEMPRESA,  @V_NRMOVBANC,   @V_NRBAIXA,    @V_NRRECIBO,
       'E',           @P_FILIPROC,    @V_DTBAIXAREC, @V_VRFINALBREC,
       @P_CDCONTCORR, @P_CDTIPOBAIXA, @P_CDOPERADOR, GETDATE(),
       '');

   UPDATE BOLETRECEBER
      SET IDSTATBREC   = 'B',
          NRBAIXAREC   = @V_NRBAIXA,
          CDTPBAIXAREC = @P_CDTIPOBAIXA,
          CDFILIBAIREC = @P_FILIPROC,
          DTLIQBOLREC  = @V_DTBAIXAREC
    WHERE (CDFILIAL     = @P_FILIPROC)
      AND (NRLANBOLREC  = @P_NRLANBOL);

   /*Atualiza saldo da conta corrente*/

   SELECT @V_DTSALDO  = MAX(DTSDOCCORR)
     FROM SDOCCORR
    WHERE CDREDUCONT  = @P_CDCONTCORR
      AND DTSDOCCORR <= @V_DTBAIXAREC;

   SELECT @V_VRATUAL = MAX(VRSDOCCORR)
     FROM SDOCCORR
    WHERE CDREDUCONT = @P_CDCONTCORR
      AND DTSDOCCORR = @V_DTSALDO;

   SET @V_VRATUAL = ISNULL(@V_VRATUAL,0) + ISNULL(@V_VRFINALBREC,0);

   IF @V_DTBAIXAREC =  @V_DTSALDO BEGIN
      UPDATE SDOCCORR
         SET @VRSDOCCORR = @V_VRATUAL,
             @VRSDOIMPLA = NULL
       WHERE CDREDUCONT  = @P_CDCONTCORR
         AND DTSDOCCORR  = @V_DTSALDO;
   END
   ELSE BEGIN
      INSERT INTO SDOCCORR
         (CDREDUCONT, DTSDOCCORR, VRSDOCCORR, VRSDOIMPLA)
      VALUES
         (@P_CDCONTCORR, @V_DTBAIXAREC, @V_VRATUAL, NULL);
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GERA_BAIXA','5.50.xxx';
GO
