import { DragDropGrid } from '@/components/drag-drop-grid/common/DragDropGrid';
import { IEventParam } from '@zeedhi/core';
import { Button } from '@zeedhi/common';

export class ZeedhiController {
  public isNotInlineEditing = true;

  public onInlineEdit({ component }: IEventParam<DragDropGrid>) {
    this.isNotInlineEditing = !component.editing;
  }

  public cancelEditing({ component }: IEventParam<Button>) {
    const grid = component.parent as DragDropGrid;
    grid.cancelEditedRows().then(() => {
      this.onInlineEdit({ component: grid });
    });
  }

  public async saveEditing({ component }: IEventParam<Button>) {
    const grid = component.parent as DragDropGrid;
    await grid.saveEditedRows();
    this.onInlineEdit({ component: grid });
  }
}
